/*
 * HtmlDisplay.java
 *
 * 
 */

/**
 *	Displayes an HTML document in a frame.
 * 
 */

import javax.swing.text.EditorKit;
import java.net.URL;
import java.util.*;
import java.io.*;
import java.awt.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.text.html.*;
import java.awt.event.ActionEvent;
import java.awt.event.*;

/**
 * Dispalyes the HTML document in a frame.
 * 
 */
public class HTMLDisplay extends JFrame implements HyperlinkListener {
    JEditorPane jep;
    EditorKit htmlKit;
    JScrollPane scrollPane;
    JFrame f;
    
    /**
     * The constructor to dispaly the frame.
     * @param file the file to place in the frame
     * @param t just for debugging
     */
	HTMLDisplay(File file, String t) {
			jep = new JEditorPane();
			jep.setEditable(false);
			htmlKit = jep.getEditorKitForContentType("text/html");
			HTMLDocument doc = (HTMLDocument) htmlKit.createDefaultDocument();
			jep.setEditorKit(htmlKit);
			jep.addHyperlinkListener( this );
			try {
				URL u = file.toURL();
				//InputStream in = u.openStream();
				//jep.read(in, doc);
				jep.setPage(u);
			}
			catch (Exception e) { e.printStackTrace();
	JOptionPane.showMessageDialog(jep, "No Internet Connection", "Error", JOptionPane.ERROR_MESSAGE); 
			}
        
			scrollPane = new JScrollPane(jep);
			f = new JFrame(t);
			f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			f.getContentPane().add(scrollPane);
			f.setSize(500, 500);
			f.setVisible(true);
        

		}
    
    

    
	/**
	 * Constructor to display the html page in a frame
	 * @param s the location of the html page
	 * @param t debugging purposes
	 */    
    HTMLDisplay(String s, String t) {
        jep = new JEditorPane();
        jep.setEditable(false);
        htmlKit = jep.getEditorKitForContentType("text/html");
        HTMLDocument doc = (HTMLDocument) htmlKit.createDefaultDocument();
        jep.setEditorKit(htmlKit);
        jep.addHyperlinkListener( this );
        try {
            URL u = new URL(s);
            
            //InputStream in = u.openStream();
            //jep.read(in, doc);
            jep.setPage(u);
        }
        catch (Exception e) {
JOptionPane.showMessageDialog(jep, "No Internet Connection", "Error", JOptionPane.ERROR_MESSAGE); 
        }
        
        scrollPane = new JScrollPane(jep);
        f = new JFrame(t);
        f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f.getContentPane().add(scrollPane);
        f.setSize(500, 500);
        f.setVisible(true);
        

    }
	/**
	 * Action to perform when an hyperlink is clicked.
	 */    
   public void hyperlinkUpdate(HyperlinkEvent event) {
    if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
      try {
        jep.setPage(event.getURL());
      } catch(IOException ioe) {
       System.err.println("Can't follow link to " 
                 + event.getURL().toExternalForm() + ": " + ioe);
      }
    }
  }
    
}

