/*
 * SimplyHTML, a word processor based on Java, HTML and CSS
 * Copyright (C) 2002 Ulrich Hilger
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.*;
import javax.swing.border.*;
import javax.swing.*;
import javax.swing.text.html.*;

/**
 * Panel to set text margin attributes.
 * @author terpword
 */

public class MarginPanel extends AttributePanel {

  private BoundariesPanel margin;
  private BoundariesPanel padding;
/** margin panel constructor */
  public MarginPanel() {
    super();

    // margin/padding panel
    setLayout(new GridLayout(2, 1, 3, 3));

    // construct margin panel
    margin = new BoundariesPanel(CSS.Attribute.MARGIN);

    // set border and title and add margin panel
    margin.setBorder(new TitledBorder(new EtchedBorder(
        EtchedBorder.LOWERED),
        FrmMain.dynRes.getResourceString(FrmMain.resources, "marginLabel")));
    this.add(margin);

    // construct padding panel
    padding = new BoundariesPanel(CSS.Attribute.PADDING);

    // set border and title adn add padding panel
    padding.setBorder(new TitledBorder(new EtchedBorder(
        EtchedBorder.LOWERED),
        FrmMain.dynRes.getResourceString(FrmMain.resources, "paddingLabel")));
    this.add(padding);
  }
/** resets the margin panel, allowing it to be refreshed */
  public void reset() {
    margin.reset();
    padding.reset();
  }
}