/*
 * SimplyHTML, a word processor based on Java, HTML and CSS
 * Copyright (C) 2002 Ulrich Hilger
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;


/**
 * Template for creation of plug-ins to application SimplyHTML.
 *
 * <p>
 * See the 'SimplyHTML Plug-In Manual' (spim.pdf) for usage.
 * </p>
 *
 * @author Ulrich Hilger
 * @author Light Development
 * @author <a href="http://www.lightdev.com">http://www.lightdev.com</a>
 * @author <a href="mailto:info@lightdev.com">info@lightdev.com</a>
 * @author published under the terms and conditions of the
 *      GNU General Public License,
 *      for details see file gpl.txt in the distribution
 *      package of this software
 *
 * @version 1, May 1, 2003
 */

public class PluginTemplate extends AbstractPlugin implements ActionListener {

  /**
   * constructor
   */
  public PluginTemplate() {
    super();

    /* replace the following with code that creates
       the plug-in component */
    c = new JPanel();
    //c.setVisible(true);
    c.add(new JLabel("PluginTemplate"));

    //System.out.println("in plugintemplatefdsfsdafsa");
  }

	public void actionPerformed(ActionEvent e) {
		owner.getEditor().setText("ok");
	}

  public void showInitialInfo() {
    /*
     put some code here to show an initial information about the plug-in
     that can be shown during launch of SimplyHTML

     This can be used to notify the user about the presence of the plug-in
     if desired
     */
  }

  /**
   * init the plug-in
   *
   * this is called by the PluginManager directly after instantiating the plug-in
   * @param owner  the owner of this plug-in
   * @param internalName  the internal name this plug-in shall have
   * @param pluginMenuId  the id of the plug-in menu in the ResourceBundle,
   * or null if no plugin-in menu is to be created
   * @param helpMenuId  the id of the help menu for this plug-in in the
   * ResourceBundle, or null if no help menu is to be created
   */
  public void initPlugin(FrmMain owner, String internalName, String pluginMenuId, String helpMenuId) {

    /* replace the names in the following line with names of
       your own plug-in as required

       the paramaters to method initPlugin of AbstractPlugin mean the following

       owner - the owner of this plug-in, i.e. the instance of class FrmMain of SimplyHTML
       internalName - the internal name this plug-in shall have
       pluginMenuId - the id of the plug-in menu in the ResourceBundle or null if no plugin-in menu is to be created
       helpMenuId  the id of the help menu for this plug-in in the ResourceBundle or null if no help menu is to be created

       see the SimplyHTML Plug-In Manual for further explanation  */
    super.initPlugin(owner, "plugintemplate", "plugintemplate", "templateHelp");

    /* the following lines are standard initialization
       steps that should be left alone */
    setOwner(owner);
    initPluginActions();
    createPluginMenu();
    createHelpMenu();
	JButton b = new JButton("click me");
	b.addActionListener(this);
	c.add(b);
  }

  /**
   * initialize actions of this plug in by creating new action instances
   * and by registering them with the DynamicResource object of the host
   * application.
   *
   * In PluginTemplate these are only dummy calls implementing instances
   * of DummyAction. Replace this with your actual set of actions.
   */
  public void initPluginActions() {
    owner.getDynRes().addAction("action1", new DummyAction(this, "action1"));
    owner.getDynRes().addAction("action2", new DummyAction(this, "action2"));
    owner.getDynRes().addAction("action3", new DummyAction(this, "action3"));
    owner.getDynRes().addAction("action4", new DummyAction(this, "action4"));
    owner.getDynRes().addAction("action5", new DummyAction(this, "action5"));
  }

  /**
   * get the name of this plug in as it shall be shown
   * on the GUI of the host application.
   *
   * overridden from AbstractAction so that we can have our own name
   * Replace this with your own name.
   */
  public String getGUIName() {
    return "PluginTemplate";
  }

}