/*
 * SimplyHTML, a word processor based on Java, HTML and CSS
 * Copyright (C) 2002 Ulrich Hilger
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. test
 */ 

import javax.swing.UIManager;
import java.awt.*;
import java.util.prefs.*;
import javax.swing.ImageIcon;
import java.io.File;

/**
 * Main class of application SimplyHTML.
 *
 * <p>This class contains method main and opens the application's main
 * frame.</p>
 *
 * @author Ulrich Hilger
 * @author Light Development
 * @author <a href="http://www.lightdev.com">http://www.lightdev.com</a>
 * @author <a href="mailto:info@lightdev.com">info@lightdev.com</a>
 * @author published under the terms and conditions of the
 *      GNU General Public License,
 *      for details see file gpl.txt in the distribution
 *      package of this software
 *
 * @version stage 11, April 27, 2003
 */



public class TerpWord implements TerpOfficeAppInterface {
	FrmMain frame;
	
	
	/**
	 * Gets the Main frame of TerpWord window to be edited
	 * @return main frame of TerpWord window
	 */
	public FrmMain getFrame()
	{
	return frame;	
	} 

	boolean isAlive = false;
	
	public void close(){
		//frame.dynRes.getAction("exit").actionPerformed(null);
		isAlive = false;
		//System.exit(0);
		
		}
		
	public boolean TerpPrint(File file)
	{
		try {
	  Preferences prefs = Preferences.userNodeForPackage( Class.forName("PrefsDialog") );
	  UIManager.setLookAndFeel(
		  prefs.get(PrefsDialog.PREFSID_LOOK_AND_FEEL,
		  UIManager.getCrossPlatformLookAndFeelClassName()));
	  /*
	  The following line causes UIManager to correctly handle alignments
	  of menu items when they do not have an icon.

	  At the Java Developer Connection, SKelvin writes:
	  "If the UI class does not find an icon it can't calculate its width :-)
	  It won't work if you just set the property to null (don't ask me
	  why), but setting to any type other than icon works."

	  (see http://forum.java.sun.com/thread.jsp?forum=57&thread=126150)
	  */
	  //UIManager.put("Menu.checkIcon", new ImageIcon("") );
	  UIManager.put("Menu.checkIcon", UIManager.get("MenuItem.checkIcon") );
	}
	catch(Exception e) {
	  e.printStackTrace();
	}
	if (file ==null)
		return false;
	else
	{
		TerpWord tw = new TerpWord(file,2);
		tw.frame.dynRes.getAction("printDoc").actionPerformed(null);
		return true;
	}
	
	}
		
	  
	   public void launch(File file)
	   {
		try {
		  Preferences prefs = Preferences.userNodeForPackage( Class.forName("PrefsDialog") );
		  UIManager.setLookAndFeel(
			  prefs.get(PrefsDialog.PREFSID_LOOK_AND_FEEL,
			  UIManager.getCrossPlatformLookAndFeelClassName()));
		  /*
		  The following line causes UIManager to correctly handle alignments
		  of menu items when they do not have an icon.

		  At the Java Developer Connection, SKelvin writes:
		  "If the UI class does not find an icon it can't calculate its width :-)
		  It won't work if you just set the property to null (don't ask me
		  why), but setting to any type other than icon works."

		  (see http://forum.java.sun.com/thread.jsp?forum=57&thread=126150)
		  */
		  //UIManager.put("Menu.checkIcon", new ImageIcon("") );
		  UIManager.put("Menu.checkIcon", UIManager.get("MenuItem.checkIcon") );
		}
		catch(Exception e) {
		  e.printStackTrace();
		}
		if (file ==null)
			new TerpWord(1);
		else
			new TerpWord(file,1);
	   	isAlive = true;
	   	}
	   public boolean alive(){return isAlive;}
	   
	   
	public TerpWord(){}
	
	/**
	 * Constructor--Construct the application test
	 */
   public TerpWord(File file, int I) {
	 frame = new FrmMain(file); // create an instance of the app's main window
	 frame.validate();

	 //Center the window
	 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	 Dimension frameSize = frame.getSize();
	 if (frameSize.height > screenSize.height) {
	   frameSize.height = screenSize.height;
	 }
	 if (frameSize.width > screenSize.width) {
	   frameSize.width = screenSize.width;
	 }
	 frame.setLocation((screenSize.width - frameSize.width) / 2,
							 (screenSize.height - frameSize.height) / 2);

	 if (I!=2)
	 {
	 	 frame.setVisible(true); // show the window
		 frame.pack();
	 }

   }
   
   /**
    * Constructor--Construct the application test
    */
  public TerpWord(int I) {
    frame = new FrmMain(); // create an instance of the app's main window
    frame.validate();

    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2,
                            (screenSize.height - frameSize.height) / 2);

	if (I!=2)
	{
		frame.setVisible(true); // show the window
		frame.pack();
	}

	//added by Xun 
	//frame.dp.writeText();
	//System.out.println("XUN " + frame.dp.getDocuments());
	//writeHTML();

  }
  
  /**
   * main method of TerpWord system
   * @param args
   */
  public static void main(String[] args) {
    try {
      Preferences prefs = Preferences.userNodeForPackage( Class.forName("PrefsDialog") );
      UIManager.setLookAndFeel(new String("javax.swing.plaf.metal.MetalLookAndFeel"));//UIManager.setLookAndFeel(
      //    prefs.get(PrefsDialog.PREFSID_LOOK_AND_FEEL,
      //    UIManager.getCrossPlatformLookAndFeelClassName()));
      /*
      The following line causes UIManager to correctly handle alignments
      of menu items when they do not have an icon.

      At the Java Developer Connection, SKelvin writes:
      "If the UI class does not find an icon it can't calculate its width :-)
      It won't work if you just set the property to null (don't ask me
      why), but setting to any type other than icon works."

      (see http://forum.java.sun.com/thread.jsp?forum=57&thread=126150)
      */
      //UIManager.put("Menu.checkIcon", new ImageIcon("") );
      UIManager.put("Menu.checkIcon", UIManager.get("MenuItem.checkIcon") );
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    if (args.length>0)
    	new TerpWord(new File(args[0]),1);
    else	
    	new TerpWord(1);
  }

}
