/*
 * WordCount.java
 *
 * Created on April 3, 2003, 8:13 PM
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;

/**
 * WordCount class is written to count the number of words, the number of characters 
 * with and without spaces, and the number of lines that was enter.
 */

public class WordCount extends JDialog 
{
	
	protected int m_option = JOptionPane.OK_OPTION;
	/**
	 * value form class method when ok is chosen
	 */
	protected int wCount;
	/**
	 * counts the number of words in the string entered
	 */
	protected int chCount;
	/**
	 * counts the number of charactors in the string
	 */
	protected int chwCount;
	/**
	 * counts the number of charactors with spaces in the string
	 */
	protected double lCount;
	/**
	 * counts the lines of the string
	 */
	//public WordCount()
	//{
		
	//}

/**
 * Count the String that passed in as parameter with number of words, number of characters,
 * number of charactors with spaces, and number of lines it contains.
 * @param txt is the string to be counted for different purpose.
 */
	public void Count(String txt) 
	{
		wCount = 0;
		chwCount = 0;
		chCount = 0;
		lCount = 0;
		int num = 0;
		String myText = "";
		int count = 0;

		chwCount = txt.length();

		StringTokenizer st = new StringTokenizer(txt);
		while (st.hasMoreTokens()) {
			wCount++;
			myText = myText.concat(st.nextToken());
		}

		chCount = myText.length();

		//get the number of newlines
		while (txt.indexOf('\n', count) != -1) {
			count = txt.indexOf('\n', count);
			count++;
			num++;
		}

		lCount = java.lang.Math.max(Math.ceil(chwCount / 80.0), num);
	}
	
	//public class WordCountDialog extends JDialog
	//{
	//	public WordCountDialog()
	//	{
	//	}
	
	/**
	 * Create new instance of WordCount by passing in two parameters JFrame and
	 * TwoContentArea, and call the super class JDialog's constructor with three
	 * parameters, JFram, String, and boolean.
	 */
	public WordCount(SHTMLEditorPane editor)
	{
		setTitle("Word Count");
		Document doc = editor.getDocument();
		
		try
		{
			Count(doc.getText(0, doc.getLength()));
		}
		catch(Exception ee)
		{
		}
		
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		
	
		centerOnScreen();
		JPanel p = new JPanel(new GridLayout(1, 2, 2, 2));
		p.setBorder(new TitledBorder(new EtchedBorder(), "Stats:"));
	
		JPanel leftPanel = new JPanel();
		leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.X_AXIS));
		JPanel labelPanel = new JPanel();
		labelPanel.setLayout(new BoxLayout(labelPanel, BoxLayout.Y_AXIS));
		JLabel wCntLabel = new JLabel("Words:");
		labelPanel.add(wCntLabel);
		JLabel chWLabel = new JLabel("Characters(without spaces):");
		labelPanel.add(chWLabel);
		JLabel chLabel = new JLabel("Characters(with spaces):");
		labelPanel.add(chLabel);
		JLabel lCntLabel = new JLabel("Lines:");
		labelPanel.add(lCntLabel);
		leftPanel.add(labelPanel);
	
		JPanel cntPanel = new JPanel(new GridLayout(4, 1, 5, 5));
		cntPanel.setBorder(new EmptyBorder(5, 20, 5, 5));
		cntPanel.setLayout(new BoxLayout(cntPanel, BoxLayout.Y_AXIS));
		JLabel wCnt = new JLabel("" + wCount);
		cntPanel.add(wCnt);
		JLabel chCnt = new JLabel("" + chCount);
		cntPanel.add(chCnt);
		JLabel chwCnt = new JLabel("" + chwCount);
		cntPanel.add(chwCnt);
		JLabel lCnt = new JLabel("" + lCount);
		cntPanel.add(lCnt);
		leftPanel.add(cntPanel);
		p.add(leftPanel);
		getContentPane().add(p);
	
		p = new JPanel(new FlowLayout());
		JPanel p1 = new JPanel(new GridLayout(1, 2, 10, 2));
		JButton btOK = new JButton("OK");
					
		ActionListener lst = new ActionListener() 
		{
			public void actionPerformed(ActionEvent e) 
			{
				m_option = JOptionPane.OK_OPTION;
				setVisible(false);
			}
		};
		
		btOK.addActionListener(lst);
		p1.add(btOK);
		p.add(p1);
		getContentPane().add(p);
	
		pack();
		//setLocationRelativeTo(parentWindow);
		setResizable(false);
		setVisible(true);
	}
	
	/**
	 * center the JDialog for wordcount on the screen
	 *
	 */
	public void centerOnScreen()
	{
		Dimension screen = getToolkit().getScreenSize();
		Rectangle bounds = getBounds();
		setLocation( (screen.width - bounds.width) / 2, (screen.height - bounds.height) / 2 );
		requestFocus();  
	}
	
}

